SystemOrganization addCategory: #EggRace!

Object subclass: #ERClass
	instanceVariableNames: 'classname methods'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EggRace'!

!ERClass class methodsFor: 'instance creation' stamp: 'DiegoLont 6/14/2011 17:56'!
on: aString
	^self basicNew
		initialize: aString;
		yourself! !

!ERClass methodsFor: 'accessing' stamp: 'DiegoLont 6/14/2011 18:25'!
addCommitElement: anElement committer: aPerson
	(self methodFrom: anElement) addCommitElement: anElement committer: aPerson! !

!ERClass methodsFor: 'accessing' stamp: 'DiegoLont 6/14/2011 17:52'!
classname
	^ classname! !

!ERClass methodsFor: 'accessing' stamp: 'DiegoLont 6/14/2011 17:52'!
classname: anObject
	classname := anObject! !

!ERClass methodsFor: 'accessing' stamp: 'StephanEggermont 7/2/2012 16:29'!
commits
	|commitSet|
	commitSet := Set new.
	methods do: [:method| commitSet addAll: (method commits collect: [:c | c commit])].
	^commitSet! !

!ERClass methodsFor: 'accessing' stamp: 'StephanEggermont 7/2/2012 16:45'!
committers
	|committerSet|
	committerSet := Set new.
	methods do: [:method| committerSet addAll: (method committers)].
	^committerSet! !

!ERClass methodsFor: 'accessing' stamp: 'DiegoLont 6/14/2011 21:09'!
complexitity
	^self methods max: [ :each | each complexity ]! !

!ERClass methodsFor: 'accessing' stamp: 'StephanEggermont 7/2/2012 15:46'!
complexity
	^self maxComplexity! !

!ERClass methodsFor: 'initialization' stamp: 'DiegoLont 6/14/2011 17:55'!
initialize: aString
	self initialize.
	classname := aString! !

!ERClass methodsFor: 'accessing' stamp: 'StephanEggermont 7/2/2012 15:46'!
maxComplexity
	^self methods inject: 0 into: [ :value :each | each complexity max: value ]! !

!ERClass methodsFor: 'accessing' stamp: 'DiegoLont 6/14/2011 18:02'!
methodCount
	^self methods size! !

!ERClass methodsFor: 'accessing' stamp: 'DiegoLont 6/14/2011 18:24'!
methodFrom: aCommit
	^self methods
		detect: [ :each | each methodname = aCommit methodname ]
		ifNone: [ self methods add: (ERMethod on: aCommit methodname) ]! !

!ERClass methodsFor: 'accessing' stamp: 'DiegoLont 6/14/2011 17:52'!
methods
	^ methods ifNil: [ methods := OrderedCollection new ]! !

!ERClass methodsFor: 'accessing' stamp: 'DiegoLont 6/14/2011 17:35'!
methods: anObject
	methods := anObject! !

!ERClass methodsFor: 'accessing' stamp: 'DiegoLont 6/15/2011 11:56'!
printString
	self classname ifNil: [ ^super printString ].
	^self classname! !

!ERClass methodsFor: 'browsing' stamp: 'DiegoLont 6/15/2011 12:50'!
showNodesInView: aView
	aView shape label.
	aView node: self.
	aView node: self forIt: [
		aView shape rectangle size: 12;
			if: [:m | m complexity < 5 ] fillColor: Color green;
			if: [:m | m complexity >= 5 and: [ m complexity < 10 ] ] fillColor: Color blue;
			if: [:m | m complexity >= 10 and: [ m complexity < 15 ] ] fillColor: Color yellow;
			if: [:m | m complexity >= 15 and: [ m complexity < 20 ] ] fillColor: Color orange;
			if: [:m | m complexity >= 20 and: [ m complexity < 25 ] ] fillColor: Color red;
			if: [:m | m complexity >= 25 ] fillColor: Color purple.
		aView nodes: (self methods sortedAs: [:m | m linecount ]).
		aView gridLayout gapSize: 2 ].
		aView verticalLineLayout! !

Object subclass: #ERCommit
	instanceVariableNames: 'sha date committer elements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EggRace'!

!ERCommit commentStamp: 'WillemVanDenEnde 7/2/2012 13:42' prior: 0!
A commit consists of a number of commit elements (a method associated with a class).

Instance Variables:
	sha	<ProtoObject | PseudoContext>
	date	<ProtoObject | PseudoContext>
	committer	<ProtoObject | PseudoContext>
	elements	<OrderedCollection>!

!ERCommit methodsFor: 'accessing' stamp: 'StephanEggermont 7/2/2012 16:28'!
addNewElementFrom: row
	self elements add: ( ERCommitElement new
		commit: self;
		filename: (row at: 4);
		linecount: (row at: 5); 
		classname:  (row at: 6);
		methodname:  (row at: 7);
		complexity:  (row at: 8); 
		yourself)! !

!ERCommit methodsFor: 'accessing' stamp: 'DiegoLont 6/29/2012 16:13'!
children
	^self elements! !

!ERCommit methodsFor: 'accessing' stamp: 'StephanEggermont 6/14/2011 06:50'!
committer
	^ committer! !

!ERCommit methodsFor: 'accessing' stamp: 'StephanEggermont 6/14/2011 06:50'!
committer: anObject
	committer := anObject! !

!ERCommit methodsFor: 'accessing' stamp: 'StephanEggermont 6/14/2011 06:50'!
date
	^ date! !

!ERCommit methodsFor: 'accessing' stamp: 'StephanEggermont 6/14/2011 06:50'!
date: anObject
	date := anObject! !

!ERCommit methodsFor: 'accessing' stamp: 'StephanEggermont 6/14/2011 07:13'!
elements
	^ elements ifNil: [elements := OrderedCollection new]! !

!ERCommit methodsFor: 'accessing' stamp: 'StephanEggermont 6/14/2011 06:54'!
elements: anObject
	elements := anObject! !

!ERCommit methodsFor: 'accessing' stamp: 'DiegoLont 6/15/2011 13:19'!
printString
	^self date! !

!ERCommit methodsFor: 'accessing' stamp: 'StephanEggermont 6/14/2011 06:50'!
sha
	^ sha! !

!ERCommit methodsFor: 'accessing' stamp: 'StephanEggermont 6/14/2011 06:50'!
sha: anObject
	sha := anObject! !

Object subclass: #ERCommitElement
	instanceVariableNames: 'commit filename linecount classname methodname complexity'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EggRace'!

!ERCommitElement commentStamp: 'WillemVanDenEnde 7/2/2012 13:46' prior: 0!
I associate a changed methodname with its' class name. You 

Instance Variables:
	filename	<AbstractSound | Announcement class | Collection | Exception class | ExceptionSet | FSLocator | FSPath | FSReference | GRPrinter | KMPPath | KMShortcut | MADescription | MooseGroup | PPParser>
	linecount	<ProtoObject | PseudoContext>
	classname	<ProtoObject | PseudoContext>
	methodname	<ProtoObject | PseudoContext>
	complexity	<MalMatrixCoercion | MalVectorCoercion | Number | String | Text>!

!ERCommitElement methodsFor: 'accessing' stamp: 'DiegoLont 6/29/2012 16:14'!
children
	^#()! !

!ERCommitElement methodsFor: 'accessing' stamp: 'StephanEggermont 6/14/2011 06:55'!
classname
	^ classname! !

!ERCommitElement methodsFor: 'accessing' stamp: 'StephanEggermont 6/14/2011 06:55'!
classname: anObject
	classname := anObject! !

!ERCommitElement methodsFor: 'accessing' stamp: 'StephanEggermont 7/2/2012 16:28'!
commit
	^ commit! !

!ERCommitElement methodsFor: 'accessing' stamp: 'StephanEggermont 7/2/2012 16:28'!
commit: anObject
	commit := anObject! !

!ERCommitElement methodsFor: 'accessing' stamp: 'DiegoLont 6/14/2011 21:11'!
complexity
	^ complexity asNumber! !

!ERCommitElement methodsFor: 'accessing' stamp: 'StephanEggermont 6/14/2011 06:55'!
complexity: anObject
	complexity := anObject! !

!ERCommitElement methodsFor: 'accessing' stamp: 'StephanEggermont 6/14/2011 06:55'!
filename
	^ filename! !

!ERCommitElement methodsFor: 'accessing' stamp: 'StephanEggermont 6/14/2011 06:55'!
filename: anObject
	filename := anObject! !

!ERCommitElement methodsFor: 'accessing' stamp: 'StephanEggermont 6/14/2011 07:17'!
linecount
	^ linecount! !

!ERCommitElement methodsFor: 'accessing' stamp: 'StephanEggermont 6/14/2011 07:17'!
linecount: anObject
	linecount := anObject! !

!ERCommitElement methodsFor: 'accessing' stamp: 'StephanEggermont 6/14/2011 06:55'!
methodname
	^ methodname! !

!ERCommitElement methodsFor: 'accessing' stamp: 'StephanEggermont 6/14/2011 06:55'!
methodname: anObject
	methodname := anObject! !

!ERCommitElement methodsFor: 'accessing' stamp: 'StephanEggermont 6/14/2011 11:36'!
printString
	^filename,': ',classname ,' ',methodname ! !

Object subclass: #ERCommitter
	instanceVariableNames: 'person commits'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EggRace'!

!ERCommitter methodsFor: 'accessing' stamp: 'DiegoLont 6/29/2012 16:13'!
children
	^self commits! !

!ERCommitter methodsFor: 'accessing' stamp: 'StephanEggermont 6/14/2011 06:51'!
commits
	^ commits ifNil: [commits := OrderedCollection new]! !

!ERCommitter methodsFor: 'accessing' stamp: 'StephanEggermont 6/14/2011 06:51'!
commits: anObject
	commits := anObject! !

!ERCommitter methodsFor: 'accessing' stamp: 'DiegoLont 6/15/2011 13:09'!
firstCommit
	self commits ifEmpty: [ ^nil ].
	^self commits last! !

!ERCommitter methodsFor: 'accessing' stamp: 'DiegoLont 6/15/2011 13:06'!
info
	^String streamContents: [:s |
		s nextPutAll: 'name = ';
			nextPutAll: self person;
			cr.
		s nextPutAll: self commits size asString, ' commits '; cr.
		s nextPutAll: 'first commit: ';
			nextPutAll: (self printDate: self firstCommit date); cr.
		s nextPutAll: 'last commit: ';
			nextPutAll: (self printDate: self lastCommit date); cr ]! !

!ERCommitter methodsFor: 'accessing' stamp: 'DiegoLont 6/15/2011 13:09'!
lastCommit
	self commits ifEmpty: [ ^nil ].
	^self commits first! !

!ERCommitter methodsFor: 'accessing' stamp: 'StephanEggermont 6/14/2011 06:51'!
person
	^ person! !

!ERCommitter methodsFor: 'accessing' stamp: 'StephanEggermont 6/14/2011 06:51'!
person: anObject
	person := anObject! !

!ERCommitter methodsFor: 'accessing' stamp: 'DiegoLont 6/15/2011 13:08'!
printDate: aDate
	aDate ifNil: [ ^'Never' ].
	^aDate! !

!ERCommitter methodsFor: 'accessing' stamp: 'StephanEggermont 6/14/2011 16:52'!
printString
	^person! !

!ERCommitter methodsFor: 'browsing' stamp: 'DiegoLont 6/15/2011 12:55'!
showView: aView
"Shows the complexity per method per commit
Green methods are short. Orange are long. Red are very long"

| d |
d := IdentityDictionary new.
self commits do: [:commit | commit elements do: [:m | d at: m put: m complexity ] ].

aView shape rectangle withoutBorder.
aView nodes: self commits forEach: [ :each |
	aView shape label.
	aView node: each.
	aView node: each forIt: [
		aView shape rectangle size: 12;
			if: [:m | (d at: m) < 5 ] fillColor: Color green;
			if: [:m | (d at: m) >= 5 and: [ (d at: m) < 10 ] ] fillColor: Color blue;
			if: [:m | (d at: m) >= 10 and: [ (d at: m) < 15 ] ] fillColor: Color yellow;
			if: [:m | (d at: m) >= 15 and: [ (d at: m) < 20 ] ] fillColor: Color orange;
			if: [:m | (d at: m) >= 20 and: [ (d at: m) < 25 ] ] fillColor: Color red;
			if: [:m | (d at: m) >= 25 ] fillColor: Color purple.
		aView nodes: (each elements sortedAs: [:m | m complexity ]).
		aView gridLayout gapSize: 2 ].
		aView verticalLineLayout ].
	
aView gridLayout
! !

Object subclass: #EREntry
	instanceVariableNames: 'entryname'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EggRace'!

!EREntry commentStamp: 'WillemVanDenEnde 7/2/2012 13:48' prior: 0!
An entry has a name, and can be a File or a Folder

Instance Variables:
	entryname	<ProtoObject>!

!EREntry class methodsFor: 'instance creation' stamp: 'DiegoLont 6/14/2011 22:12'!
on: aString
	^self basicNew
		initialize: aString;
		yourself! !

!EREntry methodsFor: 'accessing' stamp: 'DiegoLont 6/14/2011 22:10'!
asExplorerString
	^self printString! !

!EREntry methodsFor: 'accessing' stamp: 'DiegoLont 6/29/2012 16:20'!
children
	^self entries! !

!EREntry methodsFor: 'accessing' stamp: 'DiegoLont 6/15/2011 11:58'!
classes
	^#()! !

!EREntry methodsFor: 'accessing' stamp: 'DiegoLont 6/14/2011 23:18'!
entries
	^#()! !

!EREntry methodsFor: 'accessing' stamp: 'DiegoLont 6/14/2011 21:53'!
entryname
	^ entryname! !

!EREntry methodsFor: 'accessing' stamp: 'DiegoLont 6/14/2011 21:53'!
entryname: anObject
	entryname := anObject! !

!EREntry methodsFor: 'accessing' stamp: 'DiegoLont 6/15/2011 13:09'!
info
	^String streamContents: [:s |
		s nextPutAll: self entryname ]! !

!EREntry methodsFor: 'initialization' stamp: 'DiegoLont 6/14/2011 22:12'!
initialize: aString
	self initialize.
	entryname := aString! !

!EREntry methodsFor: 'accessing' stamp: 'DiegoLont 6/14/2011 22:11'!
printString
	self entryname ifNil: [ ^super printString ].
	^self entryname! !

!EREntry methodsFor: 'browsing' stamp: 'DiegoLont 6/15/2011 12:42'!
showNodesInView: aView! !

!EREntry methodsFor: 'browsing' stamp: 'DiegoLont 6/15/2011 12:25'!
showView: aView
"Shows the changes per committer per commit
Green methods are short. Orange are long. Red are very long"

| d |
d := IdentityDictionary new.
self classes do: [:cl | cl methods do: [:m | d at: m put: m complexity ] ].

aView shape rectangle withoutBorder.
aView nodes: self classes forEach: [ :each |
	aView shape label.
	aView node: each.
	aView node: each forIt: [
		aView shape rectangle size: 12;
			if: [:m | (d at: m) < 5 ] fillColor: Color green;
			if: [:m | (d at: m) >= 5 and: [ (d at: m) < 10 ] ] fillColor: Color blue;
			if: [:m | (d at: m) >= 10 and: [ (d at: m) < 15 ] ] fillColor: Color yellow;
			if: [:m | (d at: m) >= 15 and: [ (d at: m) < 20 ] ] fillColor: Color orange;
			if: [:m | (d at: m) >= 20 and: [ (d at: m) < 25 ] ] fillColor: Color red;
			if: [:m | (d at: m) >= 25 ] fillColor: Color purple.
		aView nodes: (each methods sortedAs: [:m | m complexity ]).
		aView gridLayout gapSize: 2 ].
		aView verticalLineLayout ].
	
aView gridLayout
! !

EREntry subclass: #ERFile
	instanceVariableNames: 'classes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EggRace'!

!ERFile commentStamp: 'WillemVanDenEnde 7/2/2012 13:48' prior: 0!
A file can have one or more classes

Instance Variables:
	classes	<OrderedCollection>!

!ERFile methodsFor: 'accessing' stamp: 'DiegoLont 6/14/2011 18:25'!
addCommitElement: anElement committer: aPerson
	(self classFrom: anElement) addCommitElement: anElement committer: aPerson! !

!ERFile methodsFor: 'accessing' stamp: 'DiegoLont 6/14/2011 17:51'!
classFrom: aCommit
	^self classes
		detect: [ :each | each classname = aCommit classname ]
		ifNone: [ self classes add: (ERClass on: aCommit classname) ]! !

!ERFile methodsFor: 'accessing' stamp: 'DiegoLont 6/14/2011 17:53'!
classes
	^ classes ifNil: [ classes := OrderedCollection new ]! !

!ERFile methodsFor: 'accessing' stamp: 'DiegoLont 6/14/2011 17:34'!
classes: anObject
	classes := anObject! !

!ERFile methodsFor: 'accessing' stamp: 'DiegoLont 6/14/2011 21:54'!
filename
	^self entryname! !

!ERFile methodsFor: 'accessing' stamp: 'DiegoLont 6/14/2011 21:54'!
filename: anObject
	self entryname: anObject! !

!ERFile methodsFor: 'accessing' stamp: 'DiegoLont 6/15/2011 13:13'!
info
	^String streamContents: [:s |
		s nextPutAll: self entryname; cr.
		s nextPutAll: self classes size asString, ' classes'; cr ]! !

!ERFile methodsFor: 'browsing' stamp: 'DiegoLont 6/15/2011 12:41'!
showNodesInView: aView
"Shows the changes per committer per commit
Green methods are short. Orange are long. Red are very long"

aView shape label.
aView node: self.
aView nodes: self classes forEach: [ :each | each showNodesInView: aView ].
aView gridLayout gapSize: 2! !

!ERFile methodsFor: 'browsing' stamp: 'DiegoLont 6/15/2011 12:40'!
showView: aView
"Shows the changes per committer per commit
Green methods are short. Orange are long. Red are very long"

aView shape rectangle withoutBorder.
aView nodes: self classes forEach: [ :each | each showNodesInView: aView ].	
aView gridLayout
! !

EREntry subclass: #ERFolder
	instanceVariableNames: 'fileList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EggRace'!

!ERFolder methodsFor: 'accessing' stamp: 'DiegoLont 6/15/2011 11:57'!
classes
	| retVal |
	retVal := OrderedCollection new.
	self entries do: [ :each | 
		retVal addAll: each classes ].
	^retVal! !

!ERFolder methodsFor: 'accessing' stamp: 'DiegoLont 6/14/2011 23:18'!
entries
	^self fileList entries! !

!ERFolder methodsFor: 'accessing' stamp: 'DiegoLont 6/14/2011 22:03'!
fileList
	^ fileList ifNil: [ fileList := EREntryList new ]! !

!ERFolder methodsFor: 'accessing' stamp: 'DiegoLont 6/14/2011 22:03'!
fileList: anObject
	fileList := anObject! !

!ERFolder methodsFor: 'accessing' stamp: 'DiegoLont 6/15/2011 13:14'!
info
	^String streamContents: [:s |
		s nextPutAll: self entryname; cr.
		s nextPutAll: self entries size asString, ' entries'; cr.
		s nextPutAll: self classes size asString, ' classes'; cr ]! !

!ERFolder methodsFor: 'browsing' stamp: 'DiegoLont 6/15/2011 12:42'!
showNodesInView: aView
"Shows the changes per committer per commit
Green methods are short. Orange are long. Red are very long"

aView shape label.
aView node: self.
aView nodes: self entries forEach: [ :each | each showNodesInView: aView ].
aView gridLayout gapSize: 2! !

!ERFolder methodsFor: 'browsing' stamp: 'DiegoLont 6/15/2011 13:12'!
showViewBuggy: aView
"Shows the changes per committer per commit
Green methods are short. Orange are long. Red are very long"

aView shape rectangle withoutBorder.
aView nodes: self entries forEach: [ :each | each showNodesInView: aView ].	
aView gridLayout! !

Object subclass: #EREntryList
	instanceVariableNames: 'entries'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EggRace'!

!EREntryList commentStamp: 'WillemVanDenEnde 7/2/2012 13:57' prior: 0!
An entryList provides a collection of Entries, it is built from the commit lines, splitting the file path and adding the right number of folders and files.

Instance Variables:
	entries	<OrderedCollection>!

!EREntryList class methodsFor: 'as yet unclassified' stamp: 'DiegoLont 6/14/2011 17:43'!
on: anArray
	^self basicNew
		initialize: anArray;
		yourself! !

!EREntryList methodsFor: 'accessing' stamp: 'DiegoLont 6/14/2011 18:25'!
addCommit: aCommit
	aCommit elements do: [ :each | self addCommitElement: each committer: aCommit committer ]! !

!EREntryList methodsFor: 'accessing' stamp: 'DiegoLont 6/14/2011 22:17'!
addCommitElement: anElement committer: aPerson
	(self fileFromCommit: anElement) addCommitElement: anElement committer: aPerson
	! !

!EREntryList methodsFor: 'accessing' stamp: 'DiegoLont 6/14/2011 18:21'!
addCommits: anArray
	anArray allButFirstDo: [ :each | self addCommit: each ]! !

!EREntryList methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 7/2/2012 15:48'!
classes
	| retVal |
	retVal := OrderedCollection new.
	self entries do: [ :each | 
		retVal addAll: each classes ].
	^retVal! !

!EREntryList methodsFor: 'accessing' stamp: 'DiegoLont 6/15/2011 05:31'!
entries
	^self items! !

!EREntryList methodsFor: 'accessing' stamp: 'DiegoLont 6/14/2011 21:55'!
fileFromCommit: aCommit
	^self fileFromPath: aCommit filename! !

!EREntryList methodsFor: 'accessing' stamp: 'DiegoLont 6/14/2011 22:19'!
fileFromPath: aString
	| tokens fileList |
	tokens := aString findTokens: '/'.
	tokens ifEmpty: [ ^nil ].
	fileList := self.
	tokens allButLastDo: [ :foldername |
		fileList := (fileList items
		detect: [ :each | each entryname = foldername ]
		ifNone: [ fileList items add: (ERFolder on: foldername) ]) fileList ].
	^fileList items
		detect: [ :each | each entryname = tokens last ]
		ifNone: [ fileList items add: (ERFile on: tokens last) ]! !

!EREntryList methodsFor: 'initialization' stamp: 'DiegoLont 6/14/2011 17:44'!
initialize: anArray
	self initialize.
	self addCommits: anArray! !

!EREntryList methodsFor: 'accessing' stamp: 'WillemVanDenEnde 7/2/2012 13:41'!
items
	^ entries ifNil: [ entries := OrderedCollection new ]! !

!EREntryList methodsFor: 'accessing' stamp: 'WillemVanDenEnde 7/2/2012 13:41'!
items: anObject
	entries := anObject! !

Object subclass: #ERMethod
	instanceVariableNames: 'methodname commits'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EggRace'!

!ERMethod commentStamp: 'WillemVanDenEnde 7/2/2012 13:54' prior: 0!
A Method occurs in one class and one or more commits

Instance Variables:
	methodname	<ProtoObject>
	commits	<OrderedCollection>!

!ERMethod class methodsFor: 'instance creation' stamp: 'DiegoLont 6/14/2011 17:54'!
on: aString
	^self basicNew
		initialize: aString;
		yourself! !

!ERMethod methodsFor: 'accessing' stamp: 'DiegoLont 6/14/2011 18:25'!
addCommitElement: anElement committer: aPerson
	self commits add: anElement! !

!ERMethod methodsFor: 'accessing' stamp: 'DiegoLont 6/14/2011 17:54'!
commits
	^ commits ifNil: [ commits := OrderedCollection new ]! !

!ERMethod methodsFor: 'accessing' stamp: 'DiegoLont 6/14/2011 17:39'!
commits: anObject
	commits := anObject! !

!ERMethod methodsFor: 'accessing' stamp: 'StephanEggermont 7/2/2012 16:38'!
committers
	|committers|
	committers := Set new.
	commits do: [:commit|
		committers add: commit commit committer].
	^committers! !

!ERMethod methodsFor: 'accessing' stamp: 'DiegoLont 6/29/2012 16:06'!
complexity
	self commits ifEmpty: [ ^0 ].
	^self commits last complexity ! !

!ERMethod methodsFor: 'accessing' stamp: 'DiegoLont 6/29/2012 16:08'!
info
	^String streamContents: [ :s|
		s nextPutAll: 'Methodname: ';
			nextPutAll: self methodName;
			lf.
		s nextPutAll: 'Linecount: ';
			nextPutAll: self linecount asString;
			lf.
		s nextPutAll: 'Number of commits: ';
			nextPutAll: self commits size asString;
			lf.
		s nextPutAll: 'Linecount: ';
			nextPutAll: self linecount asString;
			lf.
		s nextPutAll: 'Min complexity ';
			nextPutAll: self minComplexity asString;
			lf.
		s nextPutAll: 'Max complexity ';
			nextPutAll: self maxComplexity asString;
			lf.
		s nextPutAll: 'Current complexity ';
			nextPutAll: self complexity asString;
			lf ]! !

!ERMethod methodsFor: 'initialization' stamp: 'DiegoLont 6/14/2011 17:55'!
initialize: aString
	self initialize.
	methodname := aString! !

!ERMethod methodsFor: 'accessing' stamp: 'DiegoLont 6/15/2011 12:51'!
linecount
	self commits ifEmpty: [ ^0 ].
	^self commits last linecount ! !

!ERMethod methodsFor: 'accessing' stamp: 'DiegoLont 6/29/2012 16:07'!
maxComplexity
	^(self commits collect: [ :each | each complexity ]) max! !

!ERMethod methodsFor: 'accessing' stamp: 'DiegoLont 6/14/2011 17:53'!
methodname
	^ methodname! !

!ERMethod methodsFor: 'accessing' stamp: 'DiegoLont 6/14/2011 17:53'!
methodname: anObject
	methodname := anObject! !

!ERMethod methodsFor: 'accessing' stamp: 'StephanEggermont 7/2/2012 16:03'!
methods
	^#()! !

!ERMethod methodsFor: 'accessing' stamp: 'DiegoLont 6/29/2012 16:07'!
minComplexity
	^(self commits collect: [ :each | each complexity ]) min! !

!ERMethod methodsFor: 'printing' stamp: 'DiegoLont 6/15/2011 11:55'!
printString
	self methodname ifNil: [ ^super printString ].
	^self methodname! !

Object subclass: #ERModel
	instanceVariableNames: 'datadir projects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EggRace'!

ERModel class
	instanceVariableNames: 'default'!

!ERModel commentStamp: 'DiegoLont 6/29/2012 12:31' prior: 0!
Set the directory to load the data from in 

ERModel initialize

Open a browser on the egg race data

ERModel openBrowser

Calculate the data per committer (only once)

ERModel default projects do: [:p| p byCommitter]
!

ERModel class
	instanceVariableNames: 'default'!

!ERModel class methodsFor: 'browsing' stamp: 'DiegoLont 6/29/2012 12:20'!
browser
	"
	ERModel browser
	"
	| browser |
	browser := GLMTabulator new
		row: [ :r | r 
			column: #project;
			column: #element;
			column: #info ];
		row: #graphics;
		yourself.
	browser transmit to: #project; andShow: [ :a |
		a tree
			title: 'Projects';
			display: [ :model | model projects ] ].
	browser transmit to: #element; from: #project; andShow: [ :a |
		a list
			title: 'team';
			allowDeselection  ;
			display: [ :project | project committers ].
		a tree
			title: 'files';
			allowDeselection ; 
			display: [ :project | project entries ];
			children: [ :item :x :level | item entries ] ].
	browser transmit to: #info; from: #project; andShow: [ :a |
		a text
			title: 'info';
			display: [:project | project info]
		].
	browser transmit to: #info; from: #element; andShow: [ :a |
		a text
			title: 'info';
			display: [:element | element info]
		].
	browser transmit to: #graphics; from: #project; andShow: [ :a |
		a mondrian
			title: '#changes/committer/commit';
			painting: [ :view :project | self showProject: project view: view ] .
		a mondrian
			title: 'UML';
			painting: [ :view :project | self showUmlOn: view ] .
			].
	browser transmit to: #graphics; from: #element; andShow: [ :a |
		a mondrian
			title: '#complexity/commit/commitelement';
			painting: [ :view :element | self showElement: element view: view ] ].
	^ browser! !

!ERModel class methodsFor: 'accessing' stamp: 'DiegoLont 6/15/2011 05:00'!
classesPerFile
"Simple example of a distribution map. 
Green methods are short. Orange are long. Red are very long"

| files d view |
d := IdentityDictionary new.
files := (ERModel default projects at:1) files.
files do: [ :aFile | aFile classes do: [:cl | d at: cl put: cl methodCount ] ].

view shape rectangle withoutBorder.
view nodes: files forEach: [ :each |
	view shape label.
	view node: each.
	view node: each forIt: [
		view shape rectangle size: 12;
			if: [:m | (d at: m) < 10 ] fillColor: Color green;
			if: [:m | (d at: m) >= 10 and: [ (d at: m) < 20 ] ] fillColor: Color blue;
			if: [:m | (d at: m) >= 20 and: [ (d at: m) < 30 ] ] fillColor: Color yellow;
			if: [:m | (d at: m) >= 30 and: [ (d at: m) < 40 ] ] fillColor: Color orange;
			if: [:m | (d at: m) >= 40 and: [ (d at: m) < 50 ] ] fillColor: Color red;
			if: [:m | (d at: m) >= 50 ] fillColor: Color purple.
		view nodes: (each classes sortedAs: [:m | m complexity ]).
		view gridLayout gapSize: 2 ].
		view verticalLineLayout ].
	
view gridLayout
! !

!ERModel class methodsFor: 'maintenance' stamp: 'DiegoLont 6/14/2011 23:08'!
clean
	self default clean! !

!ERModel class methodsFor: 'defaults' stamp: 'DiegoLont 6/29/2012 13:49'!
default
	" ERModel default "
	^default ifNil: [default := self on: EggRaceConfigdata dataDir
		projects: #('eventmachine' 'active_merchant' 'diaspora' 'paperclip') ]! !

!ERModel class methodsFor: 'accessing' stamp: 'DiegoLont 6/15/2011 05:00'!
numberOfChangesPerCommitByDatePerCommiter
"Simple example of a distribution map. 
Green methods are short. Orange are long. Red are very long"

| classes d view|
d := IdentityDictionary new.
classes := (ERModel default projects at:4) committers allButFirst.
classes do: [:aClass | aClass commits do: [:m | d at: m put: m elements size ] ].

view shape rectangle withoutBorder.
view nodes: classes forEach: [ :each |
	view shape label.
	view node: each.
	view node: each forIt: [
		view shape rectangle size: 12;
			if: [:m | (d at: m) < 10 ] fillColor: Color green;
			if: [:m | (d at: m) >= 10 and: [ (d at: m) < 20 ] ] fillColor: Color blue;
			if: [:m | (d at: m) >= 20 and: [ (d at: m) < 30 ] ] fillColor: Color yellow;
			if: [:m | (d at: m) >= 30 and: [ (d at: m) < 40 ] ] fillColor: Color orange;
			if: [:m | (d at: m) >= 40 and: [ (d at: m) < 50 ] ] fillColor: Color red;
			if: [:m | (d at: m) >= 50 ] fillColor: Color purple.
		view nodes: (each commits sortedAs: [:m | (d at: m) ]).
		view gridLayout gapSize: 2 ].
		view verticalLineLayout ].
	
view gridLayout
! !

!ERModel class methodsFor: 'accessing' stamp: 'DiegoLont 6/15/2011 07:03'!
numberOfChangesPerCommitPerCommitter
"Simple example of a distribution map. 
Green methods are short. Orange are long. Red are very long"

| classes d view|
d := IdentityDictionary new.
classes := (ERModel default projects at:4) committers allButFirst.
classes do: [:aClass | aClass commits do: [:m | d at: m put: m elements size ] ].

view shape rectangle withoutBorder.
view nodes: classes forEach: [ :each |
	view shape label.
	view node: each.
	view node: each forIt: [
		view shape rectangle size: 12;
			if: [:m | (d at: m) < 10 ] fillColor: Color green;
			if: [:m | (d at: m) >= 10 and: [ (d at: m) < 20 ] ] fillColor: Color blue;
			if: [:m | (d at: m) >= 20 and: [ (d at: m) < 30 ] ] fillColor: Color yellow;
			if: [:m | (d at: m) >= 30 and: [ (d at: m) < 40 ] ] fillColor: Color orange;
			if: [:m | (d at: m) >= 40 and: [ (d at: m) < 50 ] ] fillColor: Color red;
			if: [:m | (d at: m) >= 50 ] fillColor: Color purple.
		view nodes: (each commits sortedAs: [:m | (d at: m) ]).
		view gridLayout gapSize: 2 ].
		view verticalLineLayout ].
	
view gridLayout
! !

!ERModel class methodsFor: 'instance creation' stamp: 'DiegoLont 6/29/2012 13:59'!
on: aDirectory projects: aProjects
	| retVal |
	retVal := ERModel basicNew
		initialize: aDirectory;
		yourself.
	aProjects do: [ :each | retVal addProject: (ERProject on: retVal filename: each) ].
	^retVal! !

!ERModel class methodsFor: 'browsing' stamp: 'DiegoLont 6/14/2011 22:46'!
openBrowser
	"
	ERModel openBrowser
	"
	self browser openOn: self default! !

!ERModel class methodsFor: 'defaults' stamp: 'StephanEggermont 6/14/2011 06:56'!
reset
	default := nil! !

!ERModel class methodsFor: 'mondrian' stamp: 'DiegoLont 6/15/2011 12:48'!
showElement: anElement view: aView
	anElement showView: aView
! !

!ERModel class methodsFor: 'mondrian' stamp: 'DiegoLont 6/15/2011 05:05'!
showProject: aProject view: aView
"Shows the changes per committer per commit
Green methods are short. Orange are long. Red are very long"

| committers d |
d := IdentityDictionary new.
committers := aProject committers.
committers do: [:aClass | aClass commits do: [:m | d at: m put: m elements size ] ].

aView shape rectangle withoutBorder.
aView nodes: committers forEach: [ :each |
	aView shape label.
	aView node: each.
	aView node: each forIt: [
		aView shape rectangle size: 12;
			if: [:m | (d at: m) < 10 ] fillColor: Color green;
			if: [:m | (d at: m) >= 10 and: [ (d at: m) < 20 ] ] fillColor: Color blue;
			if: [:m | (d at: m) >= 20 and: [ (d at: m) < 30 ] ] fillColor: Color yellow;
			if: [:m | (d at: m) >= 30 and: [ (d at: m) < 40 ] ] fillColor: Color orange;
			if: [:m | (d at: m) >= 40 and: [ (d at: m) < 50 ] ] fillColor: Color red;
			if: [:m | (d at: m) >= 50 ] fillColor: Color purple.
		aView nodes: (each commits sortedAs: [:m | m date ]).
		aView gridLayout gapSize: 2 ].
		aView verticalLineLayout ].
	
aView gridLayout
! !

!ERModel class methodsFor: 'mondrian' stamp: 'DiegoLont 6/29/2012 12:25'!
showUmlOn: view
	view shape umlClass.
	view nodes: (SystemNavigation default allClassesInPackageNamed: 'EggRace').
	
	view shape: (MOArrowedOrthoVerticalLineShape new).
	view edgesFrom: #superclass.
	view treeLayout! !

!ERModel methodsFor: 'accessing' stamp: 'DiegoLont 6/29/2012 13:59'!
addProject: aProject
	^self projects add: aProject! !

!ERModel methodsFor: 'maintenance' stamp: 'DiegoLont 6/14/2011 23:07'!
clean
	self projects do: [ :each | each clean ]! !

!ERModel methodsFor: 'accessing' stamp: 'StephanEggermont 6/14/2011 07:36'!
complexityMap
	| nodes view |
	nodes := self projects first commits.

	view := MOViewRenderer new.
	view interaction nodraggable.
	view interaction popupText.
	view nodes: nodes forEach: [ :node |
		view interaction nodraggable.
		view interaction popupText: [:el| el committer].
		view shape: (
			MORectangleShape new height: (node elements size)*3; width: (node elements size)*3
		).
	].
	view layout: (MOGridLayout new gapSize: 1).
	view open! !

!ERModel methodsFor: 'accessing' stamp: 'DiegoLont 6/29/2012 13:58'!
dataDir
	self shouldBeImplemented.! !

!ERModel methodsFor: 'accessing' stamp: 'DiegoLont 6/29/2012 13:59'!
datadir
	^ datadir! !

!ERModel methodsFor: 'accessing' stamp: 'DiegoLont 6/29/2012 13:53'!
initialize: aDirectory
	self initialize.
	datadir := aDirectory! !

!ERModel methodsFor: 'accessing' stamp: 'DiegoLont 6/29/2012 13:53'!
initializeOld
	super initialize.
	datadir := '/Users/diegolont/Documents/Delware/Promotie/DataVisualisatie/egg race/moose-seaside/spa-great-egg-race/repodepot-ruby/'.
	self projects
		add: (ERProject new 
			filename: 'eventmachine';
			loadFrom: datadir;
			yourself);
		add: (ERProject new 
			filename: 'active_merchant';
			loadFrom: datadir;
			yourself);
		add: (ERProject new 
			filename: 'diaspora';
			loadFrom: datadir;
			yourself);
		add: (ERProject new 
			filename: 'paperclip';
			loadFrom: datadir;
			yourself).
! !

!ERModel methodsFor: 'accessing' stamp: 'StephanEggermont 6/14/2011 06:57'!
projects
	^ projects ifNil: [projects := OrderedCollection new]! !

!ERModel methodsFor: 'accessing' stamp: 'StephanEggermont 6/14/2011 06:56'!
projects: anObject
	projects := anObject! !

!ERModel methodsFor: 'accessing' stamp: 'StephanEggermont 6/14/2011 13:41'!
simpleDistributionMap
"Simple example of a distribution map. 
Green methods are short. Orange are long. Red are very long"

| classes d view |
d := IdentityDictionary new.
classes := (ERModel default projects at:4) commits allButFirst.
classes do: [:aClass | aClass elements do: [:m | d at: m put: m complexity asNumber ] ].

view shape rectangle withoutBorder.
view nodes: classes forEach: [ :each |
	view shape label.
	view node: each.
	view node: each forIt: [
		view shape rectangle size: 12;
			if: [:m | (d at: m) < 5 ] fillColor: Color green;
			if: [:m | (d at: m) >= 5 and: [ (d at: m) < 25 ] ] fillColor: Color orange;
			if: [:m | (d at: m) >= 25 ] fillColor: Color red.
		view nodes: (each elements sortedAs: [:m | (d at: m) ]).
		view gridLayout gapSize: 2 ].
		view verticalLineLayout ].
	
view gridLayout
! !

Object subclass: #ERProject
	instanceVariableNames: 'model filename commits committers entryList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EggRace'!

!ERProject class methodsFor: 'instance creation' stamp: 'DiegoLont 6/29/2012 13:56'!
on: aModel filename: aFilename
	^self basicNew
		initialize: aModel;
		filename: aFilename;
		loadFromModel;
		yourself! !

!ERProject methodsFor: 'accessing' stamp: 'StephanEggermont 6/14/2011 16:46'!
byCommitter
	self commits do: [:commit| |committer|
		committer := self committerFor: commit.
		committer commits add: commit ]! !

!ERProject methodsFor: 'maintenance' stamp: 'StephanEggermont 7/2/2012 15:49'!
classes
	^self entryList classes! !

!ERProject methodsFor: 'maintenance' stamp: 'DiegoLont 6/14/2011 23:13'!
clean
	" entryList can build up itself: "
	entryList := nil.
	" committers should not have a person called 'committer' "
	committers ifNotEmpty: [
		committers first person = 'committer' ifTrue: [ committers remove: committers first ] ].
	commits ifNotEmpty: [
		commits first committer = 'committer' ifTrue: [ commits remove: commits first ] ]! !

!ERProject methodsFor: 'accessing' stamp: 'StephanEggermont 6/14/2011 07:12'!
commits
	^ commits ifNil: [commits:= OrderedCollection new]! !

!ERProject methodsFor: 'accessing' stamp: 'StephanEggermont 6/14/2011 06:47'!
commits: anObject
	commits := anObject! !

!ERProject methodsFor: 'accessing' stamp: 'StephanEggermont 6/14/2011 16:47'!
committerFor: commit
	^self committers detect: [:each | each person = (commit committer)]
		ifNone: [self committers add: (ERCommitter new 
			person: commit committer;
			yourself)]! !

!ERProject methodsFor: 'accessing' stamp: 'StephanEggermont 6/14/2011 13:43'!
committers
	^ committers ifNil: [committers := OrderedCollection new]! !

!ERProject methodsFor: 'accessing' stamp: 'StephanEggermont 6/14/2011 13:42'!
committers: anObject
	committers := anObject! !

!ERProject methodsFor: 'browsing' stamp: 'DiegoLont 6/14/2011 23:10'!
elementsFor: aSymbol
	aSymbol = #files ifTrue: [ ^self entryList items ].
	aSymbol = #team ifTrue: [ ^self committers ].
	^#()
! !

!ERProject methodsFor: 'accessing' stamp: 'DiegoLont 6/15/2011 04:55'!
entries
	^self entryList items! !

!ERProject methodsFor: 'accessing' stamp: 'DiegoLont 6/14/2011 22:20'!
entryList
	^entryList ifNil: [ entryList := EREntryList on: self commits ]! !

!ERProject methodsFor: 'browsing' stamp: 'DiegoLont 6/15/2011 05:27'!
fileElementsFor: aParent level: aLevel
	aLevel > 1 ifTrue: [ ^#() ].
	aParent ifNotNil: [ ^aParent entries ].
	^#()! !

!ERProject methodsFor: 'accessing' stamp: 'StephanEggermont 6/14/2011 06:46'!
filename
	^ filename! !

!ERProject methodsFor: 'accessing' stamp: 'StephanEggermont 6/14/2011 06:46'!
filename: anObject
	filename := anObject! !

!ERProject methodsFor: 'browsing' stamp: 'DiegoLont 6/15/2011 07:09'!
info
	^String streamContents: [:s |
		s nextPutAll: self commits size asString, ' commits '; cr.
		s nextPutAll: self committers size asString, ' committers']! !

!ERProject methodsFor: 'as yet unclassified' stamp: 'DiegoLont 6/29/2012 13:55'!
initialize: aModel
	self initialize.
	model := aModel! !

!ERProject methodsFor: 'accessing' stamp: 'StephanEggermont 6/14/2011 07:00'!
load
	self parse: (CSVParser parse: ((FileStream oldFileNamed: filename) converter: (TextConverter default);yourself))! !

!ERProject methodsFor: 'accessing' stamp: 'DiegoLont 6/29/2012 12:23'!
loadFrom: aDataDir
	self parse: (CSVParser parse: ((FileStream oldFileNamed: aDataDir,filename,'.csv')))! !

!ERProject methodsFor: 'accessing' stamp: 'DiegoLont 6/29/2012 14:00'!
loadFromModel
	self loadFrom: model datadir.
	self byCommitter! !

!ERProject methodsFor: 'accessing' stamp: 'DiegoLont 6/29/2012 13:54'!
model
	^ model! !

!ERProject methodsFor: 'accessing' stamp: 'DiegoLont 6/29/2012 13:54'!
model: anObject
	model := anObject! !

!ERProject methodsFor: 'accessing' stamp: 'StephanEggermont 6/14/2011 07:16'!
newCommitFrom: row
	|commit |
	commit := ERCommit new
		date: row first;
		sha: row second;
		committer: row third;
		yourself.
	self commits add: commit.
	^commit! !

!ERProject methodsFor: 'accessing' stamp: 'DiegoLont 6/29/2012 13:57'!
parse: rows
	| commit first |
	first := true.
	rows do: [ :row |
		first ifTrue: [ first := false ]
			ifFalse: [
				commit ifNil: [commit := self newCommitFrom:  row ]
				ifNotNil: [
					(commit sha ~= row second)  ifTrue: [commit := self newCommitFrom:  row ]].
				commit addNewElementFrom: row ] ]! !

!ERProject methodsFor: 'accessing' stamp: 'DiegoLont 6/14/2011 22:50'!
printString
	self filename ifNil: [ 'Unnamed project'].
	^self filename! !

!ERProject methodsFor: 'accessing' stamp: 'DiegoLont 6/29/2012 15:16'!
projectTitleString
	^self printString,' (',committers size asString,'/',commits size asString,')' 
! !
